# yaml-language-server: $schema=https://goreleaser.com/static/schema.json
# vim: set ts=2 sw=2 tw=0 fo=cnqoj

version: 2

before:
  hooks:
    - go mod tidy
    - go generate ./...

builds:
  - main: cmd/smime-encryption-testmailer/main.go
    binary: smime-encryption-testmailer
    id: default
    targets:
      - "darwin_amd64_v1"
      - "darwin_arm64"
      - "linux_amd64_v1"
    ldflags:
      - -s -w
      - -X {{.ModulePath}}/cmd.version={{.Version}}
      - -X {{.ModulePath}}/cmd.commit={{.Commit}}
      - -X {{.ModulePath}}/cmd.date={{.Date}}
  - main: cmd/smime-encryption-testmailer/main.go
    binary: smime-encryption-testmailer
    id: windows-only
    targets:
      - "windows_amd64_v1"
    ldflags:
      - -s -w
      - -X {{.ModulePath}}/cmd.version={{.Version}}
      - -X {{.ModulePath}}/cmd.commit={{.Commit}}
      - -X {{.ModulePath}}/cmd.date={{.Date}}

upx:
  -
    enabled: true

checksum:
  name_template: 'checksums.txt'

gitlab_urls:
  api: https://gitlab.kit.edu/api/v4
  download: https://gitlab.kit.edu
  use_package_registry: false
  use_job_token: false

changelog:
  sort: asc
  filters:
    exclude: []

release:
  name_template: "{{.ProjectName}} {{.Version}}"
  prerelease: auto

nfpms:
  - id: smime-encryption-testmailer
    package_name: smime-encryption-testmailer
    homepage: https://gitlab.kit.edu/kit/kit-ca/tools/smime-massmailer
    vendor: KIT-CA
    maintainer: KIT-CA <ca@kit.edu>
    description: |-
      A tool to send S/MIME encrypted emails to specific certificate holders.

    file_name_template: "{{ .ConventionalFileName }}"

    release: 1
    section: golang
    priority: optional

    formats:
      - deb
      - rpm
      - apk

    bindir: /usr/bin

    builds:
      - default
      - windows-only

    dependencies:
      - openssl

    # Custom configuration applied only to the Deb packager.
    deb:
      # Lintian overrides
      lintian_overrides:
        - statically-linked-binary
        - changelog-file-missing-in-native-package
    rpm:
      compression: lzma

archives:
  -
    id: windows-only
    builds:
      - default
      - windows-only
    format: tar.xz
    wrap_in_directory: true
    format_overrides:
      - goos: windows
        format: zip